<template>
  <UDashboardNavbar  title="Ausgangsbelege" :badge="filteredRows.length">
    <template #right>
      <UInput
          id="searchinput"
          v-model="searchString"
          icon="i-heroicons-funnel"
          autocomplete="off"
          placeholder="Suche..."
          class="hidden lg:block"
          @keydown.esc="$event.target.blur()"
      >
        <template #trailing>
          <UKbd value="/" />
        </template>
      </UInput>
      <UButton
          @click="router.push(`/createDocument/edit`)"
      >
        + Ausgangsbeleg
      </UButton>
    </template>
  </UDashboardNavbar>
  <UDashboardToolbar>
    <template #left>
<!--      <UCheckbox
          v-model="showDrafts"
          label="Entwürfe Anzeigen"
          class="my-auto mr-3"
      />-->
      <USelectMenu
          v-model="selectedTypes"
          icon="i-heroicons-adjustments-horizontal-solid"
          :options="templateTypes"
          multiple
          class="hidden lg:block"
          by="key"
          @change="tempStore.modifyFilter('createddocuments',selectedTypes)"
      >
        <template #label>
          Typ
        </template>
      </USelectMenu>
    </template>

    <template #right>
      <USelectMenu
          v-model="selectedColumns"
          icon="i-heroicons-adjustments-horizontal-solid"
          :options="templateColumns"
          multiple
          class="hidden lg:block"
          by="key"
          @change="tempStore.modifyColumns('createddocuments',selectedColumns)"
      >
        <template #label>
          Spalten
        </template>
      </USelectMenu>
      <USelectMenu
          icon="i-heroicons-adjustments-horizontal-solid"
          multiple
          v-model="selectedFilters"
          :options="['Nur offene anzeigen']"
          :color="selectedFilters.length > 0 ? 'primary' : 'white'"
          :ui-menu="{ width: 'min-w-max' }"
      >
        <template #label>
          Filter
        </template>
      </USelectMenu>
    </template>
  </UDashboardToolbar>

  <UTable
      :rows="filteredRows"
      :columns="columns"
      class="w-full"
      :ui="{ divide: 'divide-gray-200 dark:divide-gray-800' }"
      @select="selectItem"
      :empty-state="{ icon: 'i-heroicons-circle-stack-20-solid', label: 'Keine Belege anzuzeigen' }"
  >
    <template #type-data="{row}">
      {{dataStore.documentTypesForCreation[row.type].labelSingle}}
    </template>
    <template #state-data="{row}">
        <span
            v-if="row.state === 'Entwurf'"
            class="text-rose-500"
        >
          {{row.state}}
        </span>
      <span
          v-if="row.state === 'Gebucht'"
          class="text-cyan-500"
      >
          {{row.state}}
        </span>
      <span
          v-if="row.state === 'Abgeschlossen'"
          class="text-primary-500"
      >
          {{row.state}}
        </span>
    </template>
    <template #partner-data="{row}">
      <span v-if="row.customer">{{row.customer ? row.customer.name : ""}}</span>

    </template>
    <template #reference-data="{row}">
      <span v-if="row === filteredRows[selectedItem]" class="text-primary-500 font-bold">{{row.documentNumber}}</span>
      <span v-else>{{row.documentNumber}}</span>
    </template>
    <template #date-data="{row}">
      <span v-if="row.date">{{row.date ? dayjs(row.date).format("DD.MM.YY") : ''}}</span>
      <span v-if="row.documentDate">{{row.documentDate ? dayjs(row.documentDate).format("DD.MM.YY") : ''}}</span>
    </template>
    <template #dueDate-data="{row}">
      <span v-if="row.state === 'Gebucht' && row.paymentDays && ['invoices','advanceInvoices'].includes(row.type)" :class="dayjs(row.documentDate).add(row.paymentDays,'day').diff(dayjs()) <= 0 && !isPaid(row) ? ['text-rose-500'] : '' ">{{row.documentDate ? dayjs(row.documentDate).add(row.paymentDays,'day').format("DD.MM.YY") : ''}}</span>
    </template>
    <template #paid-data="{row}">
      <div v-if="(row.type === 'invoices' ||row.type === 'advanceInvoices') && row.state === 'Gebucht'">
        <span v-if="isPaid(row)" class="text-primary-500">Bezahlt</span>
        <span v-else class="text-rose-600">Offen</span>
      </div>
    </template>
    <template #amount-data="{row}">
      <span v-if="row.type !== 'deliveryNotes'">{{displayCurrency(useSum().getCreatedDocumentSum(row,items))}}</span>
    </template>
  </UTable>

</template>

<script setup>
import dayjs from "dayjs";

definePageMeta({
  middleware: "auth"
})

defineShortcuts({
  '/': () => {
    //console.log(searchinput)
    //searchinput.value.focus()
    document.getElementById("searchinput").focus()
  },
  '+': () => {
    router.push('/createDocument/edit')
  },
  'Enter': {
    usingInput: true,
    handler: () => {
      router.push(`/createDocument/show/${filteredRows.value[selectedItem.value].id}`)
    }
  },
  'arrowdown': () => {
    if(selectedItem.value < filteredRows.value.length - 1) {
      selectedItem.value += 1
    } else {
      selectedItem.value = 0
    }
  },
  'arrowup': () => {
    if(selectedItem.value === 0) {
      selectedItem.value = filteredRows.value.length - 1
    } else {
      selectedItem.value -= 1
    }
  }
})

const dataStore = useDataStore()
const tempStore = useTempStore()
const router = useRouter()

const items = ref([])
const selectedItem = ref(0)

const setupPage = async () => {
  items.value = (await useSupabaseSelect("createddocuments","*, customer(id,name), statementallocations(id,amount)","documentNumber")).filter(i => !i.archived)
}

setupPage()

const templateColumns = [
  {
    key: "reference",
    label: "Referenz",
    sortable: true
  },
  {
    key: 'type',
    label: "Typ",
    sortable: true
  },{
    key: 'state',
    label: "Status",
    sortable: true
  },
  {
    key: "amount",
    label: "Betrag",
    sortable: true
  },
  {
    key: 'partner',
    label: "Kunde",
    sortable: true
  },
  {
    key: "date",
    label: "Datum",
    sortable: true
  },
  {
    key: "paid",
    label: "Bezahlt",
    sortable: true
  },
  {
    key: "dueDate",
    label: "Fällig",
    sortable: true
  }
]
const selectedColumns = ref(tempStore.columns["createddocuments"] ? tempStore.columns["createddocuments"] : templateColumns)
const columns = computed(() => templateColumns.filter((column) => selectedColumns.value.find(i => i.key === column.key)))

const templateTypes = [
  {
    key: "invoices",
    label: "Rechnungen"
  },{
    key: "cancellationInvoices",
    label: "Stornorechnungen"
  },{
    key: "advanceInvoices",
    label: "Abschlagsrechnungen"
  }, {
    key: "quotes",
    label: "Angebote"
  }, {
    key: "deliveryNotes",
    label: "Lieferscheine"
  }, {
    key: "confirmationOrders",
    label: "Auftragsbestätigungen"
  }
]
const selectedTypes = ref(tempStore.filters["createddocuments"] ? tempStore.filters["createddocuments"] : templateTypes)
const types = computed(() => {
  return templateTypes.filter((type) => selectedTypes.value.find(i => i.key === type.key))
})

const selectItem = (item) => {
  console.log(item)

  if(item.state === "Entwurf"){
    router.push(`/createDocument/edit/${item.id}`)
  } else if(item.state !== "Entwurf") {
    router.push(`/createDocument/show/${item.id}`)
  }
}

const displayCurrency = (value, currency = "€") => {
  return `${Number(value).toFixed(2).replace(".",",")} ${currency}`
}


const searchString = ref('')
const selectedFilters = ref([])
const filteredRows = computed(() => {

  let temp = items.value.filter(i => types.value.find(x => x.key === i.type))
  temp = temp.filter(i => i.type !== "serialInvoices")

  /*if(showDrafts.value === true) {
    temp = temp.filter(i => i.state === "Entwurf")
  } else {
    temp = temp.filter(i => i.state !== "Entwurf")
  }*/

  if(selectedFilters.value.includes("Nur offene anzeigen")){
    temp = temp.filter(i => !isPaid(i))
  }


  return useSearch(searchString.value, temp.slice().reverse())

})

const calculateDocSum = (row) => {
  let sum = 0

  row.rows.forEach(row => {
    if(row.mode === "normal" || row.mode === "service" || row.mode === "free") {
      sum += row.quantity * row.price * (1 - row.discountPercent / 100) * (1 + (row.taxPercent || 0) / 100)
    }
  })

  return sum.toFixed(2)
}

const isPaid = (item) => {
  let amountPaid = 0
  item.statementallocations.forEach(allocation => amountPaid += allocation.amount)

  return Number(amountPaid.toFixed(2)) === Number(calculateDocSum(item))
}
</script>

<style scoped>

</style>